package models

import (
    i878a80d2330e89d26896388a3f487eef27b0a0e6c010c493bf80be1452208f91 "github.com/microsoft/kiota-abstractions-go/serialization"
)

// IosGeneralDeviceConfigurationable 
type IosGeneralDeviceConfigurationable interface {
    DeviceConfigurationable
    i878a80d2330e89d26896388a3f487eef27b0a0e6c010c493bf80be1452208f91.Parsable
    GetAccountBlockModification()(*bool)
    GetActivationLockAllowWhenSupervised()(*bool)
    GetAirDropBlocked()(*bool)
    GetAirDropForceUnmanagedDropTarget()(*bool)
    GetAirPlayForcePairingPasswordForOutgoingRequests()(*bool)
    GetAppleNewsBlocked()(*bool)
    GetAppleWatchBlockPairing()(*bool)
    GetAppleWatchForceWristDetection()(*bool)
    GetAppsSingleAppModeList()([]AppListItemable)
    GetAppStoreBlockAutomaticDownloads()(*bool)
    GetAppStoreBlocked()(*bool)
    GetAppStoreBlockInAppPurchases()(*bool)
    GetAppStoreBlockUIAppInstallation()(*bool)
    GetAppStoreRequirePassword()(*bool)
    GetAppsVisibilityList()([]AppListItemable)
    GetAppsVisibilityListType()(*AppListType)
    GetBluetoothBlockModification()(*bool)
    GetCameraBlocked()(*bool)
    GetCellularBlockDataRoaming()(*bool)
    GetCellularBlockGlobalBackgroundFetchWhileRoaming()(*bool)
    GetCellularBlockPerAppDataModification()(*bool)
    GetCellularBlockPersonalHotspot()(*bool)
    GetCellularBlockVoiceRoaming()(*bool)
    GetCertificatesBlockUntrustedTlsCertificates()(*bool)
    GetClassroomAppBlockRemoteScreenObservation()(*bool)
    GetClassroomAppForceUnpromptedScreenObservation()(*bool)
    GetCompliantAppListType()(*AppListType)
    GetCompliantAppsList()([]AppListItemable)
    GetConfigurationProfileBlockChanges()(*bool)
    GetDefinitionLookupBlocked()(*bool)
    GetDeviceBlockEnableRestrictions()(*bool)
    GetDeviceBlockEraseContentAndSettings()(*bool)
    GetDeviceBlockNameModification()(*bool)
    GetDiagnosticDataBlockSubmission()(*bool)
    GetDiagnosticDataBlockSubmissionModification()(*bool)
    GetDocumentsBlockManagedDocumentsInUnmanagedApps()(*bool)
    GetDocumentsBlockUnmanagedDocumentsInManagedApps()(*bool)
    GetEmailInDomainSuffixes()([]string)
    GetEnterpriseAppBlockTrust()(*bool)
    GetEnterpriseAppBlockTrustModification()(*bool)
    GetFaceTimeBlocked()(*bool)
    GetFindMyFriendsBlocked()(*bool)
    GetGameCenterBlocked()(*bool)
    GetGamingBlockGameCenterFriends()(*bool)
    GetGamingBlockMultiplayer()(*bool)
    GetHostPairingBlocked()(*bool)
    GetIBooksStoreBlocked()(*bool)
    GetIBooksStoreBlockErotica()(*bool)
    GetICloudBlockActivityContinuation()(*bool)
    GetICloudBlockBackup()(*bool)
    GetICloudBlockDocumentSync()(*bool)
    GetICloudBlockManagedAppsSync()(*bool)
    GetICloudBlockPhotoLibrary()(*bool)
    GetICloudBlockPhotoStreamSync()(*bool)
    GetICloudBlockSharedPhotoStream()(*bool)
    GetICloudRequireEncryptedBackup()(*bool)
    GetITunesBlockExplicitContent()(*bool)
    GetITunesBlockMusicService()(*bool)
    GetITunesBlockRadio()(*bool)
    GetKeyboardBlockAutoCorrect()(*bool)
    GetKeyboardBlockDictation()(*bool)
    GetKeyboardBlockPredictive()(*bool)
    GetKeyboardBlockShortcuts()(*bool)
    GetKeyboardBlockSpellCheck()(*bool)
    GetKioskModeAllowAssistiveSpeak()(*bool)
    GetKioskModeAllowAssistiveTouchSettings()(*bool)
    GetKioskModeAllowAutoLock()(*bool)
    GetKioskModeAllowColorInversionSettings()(*bool)
    GetKioskModeAllowRingerSwitch()(*bool)
    GetKioskModeAllowScreenRotation()(*bool)
    GetKioskModeAllowSleepButton()(*bool)
    GetKioskModeAllowTouchscreen()(*bool)
    GetKioskModeAllowVoiceOverSettings()(*bool)
    GetKioskModeAllowVolumeButtons()(*bool)
    GetKioskModeAllowZoomSettings()(*bool)
    GetKioskModeAppStoreUrl()(*string)
    GetKioskModeBuiltInAppId()(*string)
    GetKioskModeManagedAppId()(*string)
    GetKioskModeRequireAssistiveTouch()(*bool)
    GetKioskModeRequireColorInversion()(*bool)
    GetKioskModeRequireMonoAudio()(*bool)
    GetKioskModeRequireVoiceOver()(*bool)
    GetKioskModeRequireZoom()(*bool)
    GetLockScreenBlockControlCenter()(*bool)
    GetLockScreenBlockNotificationView()(*bool)
    GetLockScreenBlockPassbook()(*bool)
    GetLockScreenBlockTodayView()(*bool)
    GetMediaContentRatingApps()(*RatingAppsType)
    GetMediaContentRatingAustralia()(MediaContentRatingAustraliaable)
    GetMediaContentRatingCanada()(MediaContentRatingCanadaable)
    GetMediaContentRatingFrance()(MediaContentRatingFranceable)
    GetMediaContentRatingGermany()(MediaContentRatingGermanyable)
    GetMediaContentRatingIreland()(MediaContentRatingIrelandable)
    GetMediaContentRatingJapan()(MediaContentRatingJapanable)
    GetMediaContentRatingNewZealand()(MediaContentRatingNewZealandable)
    GetMediaContentRatingUnitedKingdom()(MediaContentRatingUnitedKingdomable)
    GetMediaContentRatingUnitedStates()(MediaContentRatingUnitedStatesable)
    GetMessagesBlocked()(*bool)
    GetNetworkUsageRules()([]IosNetworkUsageRuleable)
    GetNotificationsBlockSettingsModification()(*bool)
    GetPasscodeBlockFingerprintModification()(*bool)
    GetPasscodeBlockFingerprintUnlock()(*bool)
    GetPasscodeBlockModification()(*bool)
    GetPasscodeBlockSimple()(*bool)
    GetPasscodeExpirationDays()(*int32)
    GetPasscodeMinimumCharacterSetCount()(*int32)
    GetPasscodeMinimumLength()(*int32)
    GetPasscodeMinutesOfInactivityBeforeLock()(*int32)
    GetPasscodeMinutesOfInactivityBeforeScreenTimeout()(*int32)
    GetPasscodePreviousPasscodeBlockCount()(*int32)
    GetPasscodeRequired()(*bool)
    GetPasscodeRequiredType()(*RequiredPasswordType)
    GetPasscodeSignInFailureCountBeforeWipe()(*int32)
    GetPodcastsBlocked()(*bool)
    GetSafariBlockAutofill()(*bool)
    GetSafariBlocked()(*bool)
    GetSafariBlockJavaScript()(*bool)
    GetSafariBlockPopups()(*bool)
    GetSafariCookieSettings()(*WebBrowserCookieSettings)
    GetSafariManagedDomains()([]string)
    GetSafariPasswordAutoFillDomains()([]string)
    GetSafariRequireFraudWarning()(*bool)
    GetScreenCaptureBlocked()(*bool)
    GetSiriBlocked()(*bool)
    GetSiriBlockedWhenLocked()(*bool)
    GetSiriBlockUserGeneratedContent()(*bool)
    GetSiriRequireProfanityFilter()(*bool)
    GetSpotlightBlockInternetResults()(*bool)
    GetVoiceDialingBlocked()(*bool)
    GetWallpaperBlockModification()(*bool)
    GetWiFiConnectOnlyToConfiguredNetworks()(*bool)
    SetAccountBlockModification(value *bool)()
    SetActivationLockAllowWhenSupervised(value *bool)()
    SetAirDropBlocked(value *bool)()
    SetAirDropForceUnmanagedDropTarget(value *bool)()
    SetAirPlayForcePairingPasswordForOutgoingRequests(value *bool)()
    SetAppleNewsBlocked(value *bool)()
    SetAppleWatchBlockPairing(value *bool)()
    SetAppleWatchForceWristDetection(value *bool)()
    SetAppsSingleAppModeList(value []AppListItemable)()
    SetAppStoreBlockAutomaticDownloads(value *bool)()
    SetAppStoreBlocked(value *bool)()
    SetAppStoreBlockInAppPurchases(value *bool)()
    SetAppStoreBlockUIAppInstallation(value *bool)()
    SetAppStoreRequirePassword(value *bool)()
    SetAppsVisibilityList(value []AppListItemable)()
    SetAppsVisibilityListType(value *AppListType)()
    SetBluetoothBlockModification(value *bool)()
    SetCameraBlocked(value *bool)()
    SetCellularBlockDataRoaming(value *bool)()
    SetCellularBlockGlobalBackgroundFetchWhileRoaming(value *bool)()
    SetCellularBlockPerAppDataModification(value *bool)()
    SetCellularBlockPersonalHotspot(value *bool)()
    SetCellularBlockVoiceRoaming(value *bool)()
    SetCertificatesBlockUntrustedTlsCertificates(value *bool)()
    SetClassroomAppBlockRemoteScreenObservation(value *bool)()
    SetClassroomAppForceUnpromptedScreenObservation(value *bool)()
    SetCompliantAppListType(value *AppListType)()
    SetCompliantAppsList(value []AppListItemable)()
    SetConfigurationProfileBlockChanges(value *bool)()
    SetDefinitionLookupBlocked(value *bool)()
    SetDeviceBlockEnableRestrictions(value *bool)()
    SetDeviceBlockEraseContentAndSettings(value *bool)()
    SetDeviceBlockNameModification(value *bool)()
    SetDiagnosticDataBlockSubmission(value *bool)()
    SetDiagnosticDataBlockSubmissionModification(value *bool)()
    SetDocumentsBlockManagedDocumentsInUnmanagedApps(value *bool)()
    SetDocumentsBlockUnmanagedDocumentsInManagedApps(value *bool)()
    SetEmailInDomainSuffixes(value []string)()
    SetEnterpriseAppBlockTrust(value *bool)()
    SetEnterpriseAppBlockTrustModification(value *bool)()
    SetFaceTimeBlocked(value *bool)()
    SetFindMyFriendsBlocked(value *bool)()
    SetGameCenterBlocked(value *bool)()
    SetGamingBlockGameCenterFriends(value *bool)()
    SetGamingBlockMultiplayer(value *bool)()
    SetHostPairingBlocked(value *bool)()
    SetIBooksStoreBlocked(value *bool)()
    SetIBooksStoreBlockErotica(value *bool)()
    SetICloudBlockActivityContinuation(value *bool)()
    SetICloudBlockBackup(value *bool)()
    SetICloudBlockDocumentSync(value *bool)()
    SetICloudBlockManagedAppsSync(value *bool)()
    SetICloudBlockPhotoLibrary(value *bool)()
    SetICloudBlockPhotoStreamSync(value *bool)()
    SetICloudBlockSharedPhotoStream(value *bool)()
    SetICloudRequireEncryptedBackup(value *bool)()
    SetITunesBlockExplicitContent(value *bool)()
    SetITunesBlockMusicService(value *bool)()
    SetITunesBlockRadio(value *bool)()
    SetKeyboardBlockAutoCorrect(value *bool)()
    SetKeyboardBlockDictation(value *bool)()
    SetKeyboardBlockPredictive(value *bool)()
    SetKeyboardBlockShortcuts(value *bool)()
    SetKeyboardBlockSpellCheck(value *bool)()
    SetKioskModeAllowAssistiveSpeak(value *bool)()
    SetKioskModeAllowAssistiveTouchSettings(value *bool)()
    SetKioskModeAllowAutoLock(value *bool)()
    SetKioskModeAllowColorInversionSettings(value *bool)()
    SetKioskModeAllowRingerSwitch(value *bool)()
    SetKioskModeAllowScreenRotation(value *bool)()
    SetKioskModeAllowSleepButton(value *bool)()
    SetKioskModeAllowTouchscreen(value *bool)()
    SetKioskModeAllowVoiceOverSettings(value *bool)()
    SetKioskModeAllowVolumeButtons(value *bool)()
    SetKioskModeAllowZoomSettings(value *bool)()
    SetKioskModeAppStoreUrl(value *string)()
    SetKioskModeBuiltInAppId(value *string)()
    SetKioskModeManagedAppId(value *string)()
    SetKioskModeRequireAssistiveTouch(value *bool)()
    SetKioskModeRequireColorInversion(value *bool)()
    SetKioskModeRequireMonoAudio(value *bool)()
    SetKioskModeRequireVoiceOver(value *bool)()
    SetKioskModeRequireZoom(value *bool)()
    SetLockScreenBlockControlCenter(value *bool)()
    SetLockScreenBlockNotificationView(value *bool)()
    SetLockScreenBlockPassbook(value *bool)()
    SetLockScreenBlockTodayView(value *bool)()
    SetMediaContentRatingApps(value *RatingAppsType)()
    SetMediaContentRatingAustralia(value MediaContentRatingAustraliaable)()
    SetMediaContentRatingCanada(value MediaContentRatingCanadaable)()
    SetMediaContentRatingFrance(value MediaContentRatingFranceable)()
    SetMediaContentRatingGermany(value MediaContentRatingGermanyable)()
    SetMediaContentRatingIreland(value MediaContentRatingIrelandable)()
    SetMediaContentRatingJapan(value MediaContentRatingJapanable)()
    SetMediaContentRatingNewZealand(value MediaContentRatingNewZealandable)()
    SetMediaContentRatingUnitedKingdom(value MediaContentRatingUnitedKingdomable)()
    SetMediaContentRatingUnitedStates(value MediaContentRatingUnitedStatesable)()
    SetMessagesBlocked(value *bool)()
    SetNetworkUsageRules(value []IosNetworkUsageRuleable)()
    SetNotificationsBlockSettingsModification(value *bool)()
    SetPasscodeBlockFingerprintModification(value *bool)()
    SetPasscodeBlockFingerprintUnlock(value *bool)()
    SetPasscodeBlockModification(value *bool)()
    SetPasscodeBlockSimple(value *bool)()
    SetPasscodeExpirationDays(value *int32)()
    SetPasscodeMinimumCharacterSetCount(value *int32)()
    SetPasscodeMinimumLength(value *int32)()
    SetPasscodeMinutesOfInactivityBeforeLock(value *int32)()
    SetPasscodeMinutesOfInactivityBeforeScreenTimeout(value *int32)()
    SetPasscodePreviousPasscodeBlockCount(value *int32)()
    SetPasscodeRequired(value *bool)()
    SetPasscodeRequiredType(value *RequiredPasswordType)()
    SetPasscodeSignInFailureCountBeforeWipe(value *int32)()
    SetPodcastsBlocked(value *bool)()
    SetSafariBlockAutofill(value *bool)()
    SetSafariBlocked(value *bool)()
    SetSafariBlockJavaScript(value *bool)()
    SetSafariBlockPopups(value *bool)()
    SetSafariCookieSettings(value *WebBrowserCookieSettings)()
    SetSafariManagedDomains(value []string)()
    SetSafariPasswordAutoFillDomains(value []string)()
    SetSafariRequireFraudWarning(value *bool)()
    SetScreenCaptureBlocked(value *bool)()
    SetSiriBlocked(value *bool)()
    SetSiriBlockedWhenLocked(value *bool)()
    SetSiriBlockUserGeneratedContent(value *bool)()
    SetSiriRequireProfanityFilter(value *bool)()
    SetSpotlightBlockInternetResults(value *bool)()
    SetVoiceDialingBlocked(value *bool)()
    SetWallpaperBlockModification(value *bool)()
    SetWiFiConnectOnlyToConfiguredNetworks(value *bool)()
}
