package models

import (
    i878a80d2330e89d26896388a3f487eef27b0a0e6c010c493bf80be1452208f91 "github.com/microsoft/kiota-abstractions-go/serialization"
)

// DefenderDetectedMalwareActions specify Defender’s actions to take on detected Malware per threat level.
type DefenderDetectedMalwareActions struct {
    // Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
    additionalData map[string]interface{}
    // Indicates a Defender action to take for high severity Malware threat detected. Possible values are: deviceDefault, clean, quarantine, remove, allow, userDefined, block.
    highSeverity *DefenderThreatAction
    // Indicates a Defender action to take for low severity Malware threat detected. Possible values are: deviceDefault, clean, quarantine, remove, allow, userDefined, block.
    lowSeverity *DefenderThreatAction
    // Indicates a Defender action to take for moderate severity Malware threat detected. Possible values are: deviceDefault, clean, quarantine, remove, allow, userDefined, block.
    moderateSeverity *DefenderThreatAction
    // Indicates a Defender action to take for severe severity Malware threat detected. Possible values are: deviceDefault, clean, quarantine, remove, allow, userDefined, block.
    severeSeverity *DefenderThreatAction
}
// NewDefenderDetectedMalwareActions instantiates a new defenderDetectedMalwareActions and sets the default values.
func NewDefenderDetectedMalwareActions()(*DefenderDetectedMalwareActions) {
    m := &DefenderDetectedMalwareActions{
    }
    m.SetAdditionalData(make(map[string]interface{}));
    return m
}
// CreateDefenderDetectedMalwareActionsFromDiscriminatorValue creates a new instance of the appropriate class based on discriminator value
func CreateDefenderDetectedMalwareActionsFromDiscriminatorValue(parseNode i878a80d2330e89d26896388a3f487eef27b0a0e6c010c493bf80be1452208f91.ParseNode)(i878a80d2330e89d26896388a3f487eef27b0a0e6c010c493bf80be1452208f91.Parsable, error) {
    return NewDefenderDetectedMalwareActions(), nil
}
// GetAdditionalData gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
func (m *DefenderDetectedMalwareActions) GetAdditionalData()(map[string]interface{}) {
    if m == nil {
        return nil
    } else {
        return m.additionalData
    }
}
// GetFieldDeserializers the deserialization information for the current model
func (m *DefenderDetectedMalwareActions) GetFieldDeserializers()(map[string]func(i878a80d2330e89d26896388a3f487eef27b0a0e6c010c493bf80be1452208f91.ParseNode)(error)) {
    res := make(map[string]func(i878a80d2330e89d26896388a3f487eef27b0a0e6c010c493bf80be1452208f91.ParseNode)(error))
    res["highSeverity"] = func (n i878a80d2330e89d26896388a3f487eef27b0a0e6c010c493bf80be1452208f91.ParseNode) error {
        val, err := n.GetEnumValue(ParseDefenderThreatAction)
        if err != nil {
            return err
        }
        if val != nil {
            m.SetHighSeverity(val.(*DefenderThreatAction))
        }
        return nil
    }
    res["lowSeverity"] = func (n i878a80d2330e89d26896388a3f487eef27b0a0e6c010c493bf80be1452208f91.ParseNode) error {
        val, err := n.GetEnumValue(ParseDefenderThreatAction)
        if err != nil {
            return err
        }
        if val != nil {
            m.SetLowSeverity(val.(*DefenderThreatAction))
        }
        return nil
    }
    res["moderateSeverity"] = func (n i878a80d2330e89d26896388a3f487eef27b0a0e6c010c493bf80be1452208f91.ParseNode) error {
        val, err := n.GetEnumValue(ParseDefenderThreatAction)
        if err != nil {
            return err
        }
        if val != nil {
            m.SetModerateSeverity(val.(*DefenderThreatAction))
        }
        return nil
    }
    res["severeSeverity"] = func (n i878a80d2330e89d26896388a3f487eef27b0a0e6c010c493bf80be1452208f91.ParseNode) error {
        val, err := n.GetEnumValue(ParseDefenderThreatAction)
        if err != nil {
            return err
        }
        if val != nil {
            m.SetSevereSeverity(val.(*DefenderThreatAction))
        }
        return nil
    }
    return res
}
// GetHighSeverity gets the highSeverity property value. Indicates a Defender action to take for high severity Malware threat detected. Possible values are: deviceDefault, clean, quarantine, remove, allow, userDefined, block.
func (m *DefenderDetectedMalwareActions) GetHighSeverity()(*DefenderThreatAction) {
    if m == nil {
        return nil
    } else {
        return m.highSeverity
    }
}
// GetLowSeverity gets the lowSeverity property value. Indicates a Defender action to take for low severity Malware threat detected. Possible values are: deviceDefault, clean, quarantine, remove, allow, userDefined, block.
func (m *DefenderDetectedMalwareActions) GetLowSeverity()(*DefenderThreatAction) {
    if m == nil {
        return nil
    } else {
        return m.lowSeverity
    }
}
// GetModerateSeverity gets the moderateSeverity property value. Indicates a Defender action to take for moderate severity Malware threat detected. Possible values are: deviceDefault, clean, quarantine, remove, allow, userDefined, block.
func (m *DefenderDetectedMalwareActions) GetModerateSeverity()(*DefenderThreatAction) {
    if m == nil {
        return nil
    } else {
        return m.moderateSeverity
    }
}
// GetSevereSeverity gets the severeSeverity property value. Indicates a Defender action to take for severe severity Malware threat detected. Possible values are: deviceDefault, clean, quarantine, remove, allow, userDefined, block.
func (m *DefenderDetectedMalwareActions) GetSevereSeverity()(*DefenderThreatAction) {
    if m == nil {
        return nil
    } else {
        return m.severeSeverity
    }
}
// Serialize serializes information the current object
func (m *DefenderDetectedMalwareActions) Serialize(writer i878a80d2330e89d26896388a3f487eef27b0a0e6c010c493bf80be1452208f91.SerializationWriter)(error) {
    if m.GetHighSeverity() != nil {
        cast := (*m.GetHighSeverity()).String()
        err := writer.WriteStringValue("highSeverity", &cast)
        if err != nil {
            return err
        }
    }
    if m.GetLowSeverity() != nil {
        cast := (*m.GetLowSeverity()).String()
        err := writer.WriteStringValue("lowSeverity", &cast)
        if err != nil {
            return err
        }
    }
    if m.GetModerateSeverity() != nil {
        cast := (*m.GetModerateSeverity()).String()
        err := writer.WriteStringValue("moderateSeverity", &cast)
        if err != nil {
            return err
        }
    }
    if m.GetSevereSeverity() != nil {
        cast := (*m.GetSevereSeverity()).String()
        err := writer.WriteStringValue("severeSeverity", &cast)
        if err != nil {
            return err
        }
    }
    {
        err := writer.WriteAdditionalData(m.GetAdditionalData())
        if err != nil {
            return err
        }
    }
    return nil
}
// SetAdditionalData sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
func (m *DefenderDetectedMalwareActions) SetAdditionalData(value map[string]interface{})() {
    if m != nil {
        m.additionalData = value
    }
}
// SetHighSeverity sets the highSeverity property value. Indicates a Defender action to take for high severity Malware threat detected. Possible values are: deviceDefault, clean, quarantine, remove, allow, userDefined, block.
func (m *DefenderDetectedMalwareActions) SetHighSeverity(value *DefenderThreatAction)() {
    if m != nil {
        m.highSeverity = value
    }
}
// SetLowSeverity sets the lowSeverity property value. Indicates a Defender action to take for low severity Malware threat detected. Possible values are: deviceDefault, clean, quarantine, remove, allow, userDefined, block.
func (m *DefenderDetectedMalwareActions) SetLowSeverity(value *DefenderThreatAction)() {
    if m != nil {
        m.lowSeverity = value
    }
}
// SetModerateSeverity sets the moderateSeverity property value. Indicates a Defender action to take for moderate severity Malware threat detected. Possible values are: deviceDefault, clean, quarantine, remove, allow, userDefined, block.
func (m *DefenderDetectedMalwareActions) SetModerateSeverity(value *DefenderThreatAction)() {
    if m != nil {
        m.moderateSeverity = value
    }
}
// SetSevereSeverity sets the severeSeverity property value. Indicates a Defender action to take for severe severity Malware threat detected. Possible values are: deviceDefault, clean, quarantine, remove, allow, userDefined, block.
func (m *DefenderDetectedMalwareActions) SetSevereSeverity(value *DefenderThreatAction)() {
    if m != nil {
        m.severeSeverity = value
    }
}
